OGRE: Ogre::DepthBuffer Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::DepthBuffer Class Reference
Core » RenderSystem

An abstract class that contains a depth/stencil buffer. More...

`#include <OgreDepthBuffer.h>`

Inheritance diagram for Ogre::DepthBuffer:
[legend]

## Public Types
enum | PoolId { POOL_NO_DEPTH = RBP_NONE , POOL_MANUAL_USAGE = RBP_NONE , POOL_DEFAULT = RBP_DEFAULT }

## Public Member Functions
| DepthBuffer (uint16 poolId, uint32 width, uint32 height, uint32 fsaa, bool manual)
virtual | ~DepthBuffer ()
virtual void | _notifyRenderTargetAttached (RenderTarget *renderTarget)
| Called when a RenderTarget is attaches this DepthBuffer.
virtual void | _notifyRenderTargetDetached (RenderTarget *renderTarget)
| Called when a RenderTarget is detaches from this DepthBuffer.
void | _setPoolId (uint16 poolId)
uint32 | getFSAA () const
virtual uint32 | getHeight () const
virtual uint16 | getPoolId () const
| Gets the pool id in which this DepthBuffer lives.
virtual uint32 | getWidth () const
virtual bool | isCompatible (RenderTarget *renderTarget) const
| Returns whether the specified RenderTarget is compatible with this DepthBuffer That is, this DepthBuffer can be attached to that RenderTarget.
bool | isManual () const
| Manual DepthBuffers are cleared in RenderSystem's destructor.

## Detailed Description

An abstract class that contains a depth/stencil buffer.

Depth Buffers can be attached to render targets. Note we handle Depth & Stencil together. DepthBuffer sharing is handled automatically for you. However, there are times where you want to specifically control depth buffers to achieve certain effects or increase performance. You can control this by hinting Ogre with POOL IDs. Created depth buffers can live in different pools, or all together in the same one. Usually, a depth buffer can only be attached to a RenderTarget if it's dimensions are bigger and have the same bit depth and same multisample settings. Depth Buffers are created automatically for new RTs when needed, and stored in the pool where the RenderTarget should have drawn from. By default, all RTs have the Id POOL_DEFAULT, which means all depth buffers are stored by default in that pool. By choosing a different Pool Id for a specific RenderTarget, that RT will only retrieve depth buffers from that pool, therefore not conflicting with sharing depth buffers with other RTs (such as shadows maps). Setting an RT to POOL_MANUAL_USAGE means Ogre won't manage the DepthBuffer for you (not recommended) RTs with POOL_NO_DEPTH are very useful when you don't want to create a DepthBuffer for it. You can still manually attach a depth buffer though as internally POOL_NO_DEPTH & POOL_MANUAL_USAGE are handled in the same way.

Behavior is consistent across all render systems, if, and only if, the same RSC flags are set RSC flags that affect this class are:

- RSC_RTT_MAIN_DEPTHBUFFER_ATTACHABLE: some APIs (ie. OpenGL w/ FBO) don't allow using the main depth buffer for offscreen RTTs. When this flag is set, the depth buffer can be shared between the main window and an RTT.
- RSC_RTT_INDEPENDENT_BUFFER_SIZE: When this flag isn't set, the depth buffer can only be shared across RTTs who have the EXACT same resolution. When it's set, it can be shared with RTTs as long as they have a resolution less or equal than the depth buffer's.

Design discussion http://www.ogre3d.org/forums/viewtopic.php?f=4&t=53534&p=365582

The documentation for this class was generated from the following file:

- OgreDepthBuffer.h